LoadModeEvent = {};
LoadModeEvent_mt = Class(LoadModeEvent, Event);

InitEventClass(LoadModeEvent, "LoadModeEvent");

function LoadModeEvent:emptyNew()
    local self = Event:new(LoadModeEvent_mt);
    self.className="LoadModeEvent";
    return self;
end;

function LoadModeEvent:new(vehicle, state)
    local self = LoadModeEvent:emptyNew()
    self.vehicle = vehicle;
	self.state = state;
    return self;
end;

function LoadModeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function LoadModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function LoadModeEvent:run(connection)   
	self.vehicle:LoadMode(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(LoadModeEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
    end;
end;

function LoadModeEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(LoadModeEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(LoadModeEvent:new(vehicle, state));
		end;
	end;
end;